proc iml;
T={
  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   2   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   1   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   1   0   0   0   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   6   0   8   0   3   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   7   0   0   0   0   0   0   0,
  0   0   0   1   0   0   0   0   0  10   0  34   0   1   0   1   0   1   0   0,
  0   0   0   0   0   0   0   1   0   0   1   1   8   0   1   0   0   1   0   0,
  0   0   0   0   0   0   0   0   0   0   0   3   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   1   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0,
  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0};
T={
0 0  0  2  0 0  0  0  0  0  0  0,
0 0  1  3  0 0  0  2  3  0  0  0,
2 3 26 35  7 0  2 10 11  3  4  1,
2 3 22 26  6 2  4  4 10  2  2  0,
0 1  7 10  2 0  0  2  2  1  1  0,
0 0  1  4  0 1  0  1  0  0  0  0,
0 2  5  4  1 1  0  0  0  2  0  0,
0 0  2  6  1 0  2  0  2  0  0  0,
0 3  6 19  6 0  0  2  5  3  0  0,
0 0  3  1  1 0  0  0  1  0  0  0,
0 0  0  2  0 0  0  0  0  0  0  0,
0 0  1  0  0 0  0  0  0  0  0  0};

/* MB Miller's Matlab code:
 
T=T-diag(diag(T));
[i,j]=find(tril(T)+triu(T)');

m=size(T,1);
NH=length(i);
for k=1:NH, C(k,1)=T(i(k),j(k))+T(j(k),i(k)); end
T0=T;
for K=1:n,
   for L=1:NH, T(i(L),j(L))=sum(rand(C(L),1)<.5); T(j(L),i(L))=C(L)-T(i(L),j(L)); end
   X(K,1)=((m-1)/m)*sum(((sum(T)-sum(T')).^2)./(sum(T)+sum(T')));
end
MCp=mean(X>=((m-1)/m)*sum(((sum(T0)-sum(T0')).^2)./(sum(T0)+sum(T0'))))
*/

/* My own SAS code -- JH Zhao 20/07/1999*/

T=T-diag(diag(T));
/*
keep=loc(T[+,]+T[,+]`);
T=T[keep,keep];
*/
m=nrow(T);
b=j(m,m,0);
i=j(m*(m-1)/2,1,0);
j=j(m*(m-1)/2,1,0);
do ii=1 to m;
   do jj=1 to ii-1;
      b[ii,jj]=T[ii,jj]+T[jj,ii];
   end;
end;
l=0;
do ii=1 to m-1;
   do jj=ii+1 to m;
      if b[jj,ii]>0 then do;
         l=l+1;
         i[l]=jj;
         j[l]=ii;
      end;
   end;
end;
NH=l;
c=j(1,NH,0);
do k=1 to NH; c[k]=T[i[k],j[k]]+T[j[k],i[k]]; end;
t0=T;
c0=(m-1)/m;
n=1000;
seed=200;
/*Spielman & Ewen's statistic*/
x=j(1,n,0);
do k=1 to n;
   do L=1 to NH;
      ss=0;
      do ll=1 to c[L];
         if ranuni(seed)<0.5 then ss=ss+1;
      end;
      T[i[L],j[L]]=ss;
      T[j[L],i[L]]=C[L]-T[i[L],j[L]];
   end;
   tc=t[+,];
   tr=t[,+];
   X[k]=c0*sum((tc-tr`)##2/(tc+tr`));
end;
MCp=0;
tc=t0[+,];
tr=t0[,+]`;
s0=c0*sum((tc-tr)##2/(tc+tr));
do k=1 to n;
   if X[k]>=s0 then MCp=MCp+1;
end;
p=MCp/n;
s2=sqrt(p*(1-p)/n);
print 'statistics, Empirical p-value and standard error: ' s0 p s2;
quit;
